diff -Npur gnumach.old/ipc/ipc_right.c gnumach.new/ipc/ipc_right.c
--- gnumach.old/ipc/ipc_right.c	2001-04-05 03:39:19.000000000 -0300
+++ gnumach.new/ipc/ipc_right.c	2006-04-05 13:19:21.000000000 -0300
@@ -33,8 +33,6 @@
  *	Functions to manipulate IPC capabilities.
  */
 
-#include <mach_ipc_compat.h>
-
 #include <mach/boolean.h>
 #include <mach/kern_return.h>
 #include <mach/port.h>
@@ -215,13 +213,6 @@ ipc_right_dnrequest(
 				/* port is locked and active */
 
 				if (notify == IP_NULL) {
-#if	MACH_IPC_COMPAT
-					if (bits & IE_BITS_COMPAT) {
-						assert(entry->ie_request != 0);
-
-						previous = IP_NULL;
-					} else
-#endif	/* MACH_IPC_COMPAT */
 					previous = ipc_right_dncancel_macro(
 						space, port, name, entry);
 
@@ -261,20 +252,10 @@ ipc_right_dnrequest(
 				ip_unlock(port);
 
 				entry->ie_request = request;
-#if	MACH_IPC_COMPAT
-				entry->ie_bits = bits &~ IE_BITS_COMPAT;
-#endif	/* MACH_IPC_COMPAT */
 				is_write_unlock(space);
 				break;
 			}
 
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT) {
-				is_write_unlock(space);
-				return KERN_INVALID_NAME;
-			}
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = entry->ie_bits;
 			assert(bits & MACH_PORT_TYPE_DEAD_NAME);
 		}
@@ -335,19 +316,6 @@ ipc_right_dncancel(
 	dnrequest = ipc_port_dncancel(port, name, entry->ie_request);
 	entry->ie_request = 0;
 
-#if	MACH_IPC_COMPAT
-	assert(!ipr_spacep(dnrequest) == !(entry->ie_bits & IE_BITS_COMPAT));
-
-	/* if this is actually a space ptr, just release the ref */
-
-	if (entry->ie_bits & IE_BITS_COMPAT) {
-		assert(space == ipr_space(dnrequest));
-
-		is_release(space);
-		dnrequest = IP_NULL;
-	}
-#endif	/* MACH_IPC_COMPAT */
-
 	return dnrequest;
 }
 
@@ -370,57 +338,6 @@ ipc_right_inuse(space, name, entry)
 	ipc_entry_bits_t bits = entry->ie_bits;
 
 	if (IE_BITS_TYPE(bits) != MACH_PORT_TYPE_NONE) {
-#if	MACH_IPC_COMPAT
-		mach_port_type_t type = IE_BITS_TYPE(bits);
-
-		/*
-		 *	There is yet hope.  If the port has died, we
-		 *	must clean up the entry so it's as good as new.
-		 */
-
-		if ((bits & IE_BITS_COMPAT) &&
-		    ((type == MACH_PORT_TYPE_SEND) ||
-		     (type == MACH_PORT_TYPE_SEND_ONCE))) {
-			ipc_port_t port;
-			boolean_t active;
-
-			assert(IE_BITS_UREFS(bits) > 0);
-			assert(entry->ie_request != 0);
-
-			port = (ipc_port_t) entry->ie_object;
-			assert(port != IP_NULL);
-
-			ip_lock(port);
-			active = ip_active(port);
-			ip_unlock(port);
-
-			if (!active) {
-				if (type == MACH_PORT_TYPE_SEND) {
-					/* clean up msg-accepted request */
-
-					if (bits & IE_BITS_MAREQUEST)
-						ipc_marequest_cancel(
-								space, name);
-
-					ipc_hash_delete(
-						space, (ipc_object_t) port,
-						name, entry);
-				} else {
-					assert(IE_BITS_UREFS(bits) == 1);
-					assert(!(bits & IE_BITS_MAREQUEST));
-				}
-
-				ipc_port_release(port);
-
-				entry->ie_request = 0;
-				entry->ie_object = IO_NULL;
-				entry->ie_bits &= ~IE_BITS_RIGHT_MASK;
-
-				return FALSE;
-			}
-		}
-#endif	/* MACH_IPC_COMPAT */
-
 		is_write_unlock(space);
 		return TRUE;
 	}
@@ -438,11 +355,6 @@ ipc_right_inuse(space, name, entry)
  *		If returns FALSE, the port is also locked and active.
  *		Otherwise, entry is converted to a dead name, freeing
  *		a reference to port.
- *
- *		[MACH_IPC_COMPAT] If the port is dead, and this is a
- *		compat mode entry, then the port reference is released
- *		and the entry is destroyed.  The call returns TRUE,
- *		and the space is left locked.
  */
 
 boolean_t
@@ -488,18 +400,6 @@ ipc_right_check(space, port, name, entry
 
 	ipc_port_release(port);
 
-#if	MACH_IPC_COMPAT
-	if (bits & IE_BITS_COMPAT) {
-		assert(entry->ie_request != 0);
-		entry->ie_request = 0;
-
-		entry->ie_object = IO_NULL;
-		ipc_entry_dealloc(space, name, entry);
-
-		return TRUE;
-	}
-#endif	/* MACH_IPC_COMPAT */
-
 	/* convert entry to dead name */
 
 	bits = (bits &~ IE_BITS_TYPE_MASK) | MACH_PORT_TYPE_DEAD_NAME;
@@ -724,10 +624,6 @@ ipc_right_destroy(
 			ipc_entry_dealloc(space, name, entry);
 			is_write_unlock(space);
 
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				return KERN_INVALID_NAME;
-#endif	/* MACH_IPC_COMPAT */
 			break;
 		}
 
@@ -797,8 +693,6 @@ ipc_right_destroy(
  *	Returns:
  *		KERN_SUCCESS		A user ref was released.
  *		KERN_INVALID_RIGHT	Entry has wrong type.
- *		KERN_INVALID_NAME	[MACH_IPC_COMPAT]
- *			Caller should pretend lookup of entry failed.
  */
 
 kern_return_t
@@ -840,11 +734,6 @@ ipc_right_dealloc(space, name, entry)
 		assert(port != IP_NULL);
 
 		if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = entry->ie_bits;
 			assert(IE_BITS_TYPE(bits) == MACH_PORT_TYPE_DEAD_NAME);
 			goto dead_name;
@@ -879,11 +768,6 @@ ipc_right_dealloc(space, name, entry)
 		assert(port != IP_NULL);
 
 		if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = entry->ie_bits;
 			assert(IE_BITS_TYPE(bits) == MACH_PORT_TYPE_DEAD_NAME);
 			goto dead_name;
@@ -971,12 +855,6 @@ ipc_right_dealloc(space, name, entry)
 	}
 
 	return KERN_SUCCESS;
-
-#if	MACH_IPC_COMPAT
-    invalid_name:
-	is_write_unlock(space);
-	return KERN_INVALID_NAME;
-#endif	/* MACH_IPC_COMPAT */
 }
 
 /*
@@ -992,8 +870,6 @@ ipc_right_dealloc(space, name, entry)
  *		KERN_INVALID_RIGHT	Entry has wrong type.
  *		KERN_INVALID_VALUE	Bad delta for the right.
  *		KERN_UREFS_OVERFLOW	OK delta, except would overflow.
- *		KERN_INVALID_NAME	[MACH_IPC_COMPAT]
- *			Caller should pretend lookup of entry failed.
  */
 
 kern_return_t
@@ -1076,17 +952,6 @@ ipc_right_delta(space, name, entry, righ
 		assert(port->ip_receiver_name == name);
 		assert(port->ip_receiver == space);
 
-#if	MACH_IPC_COMPAT
-		if (bits & IE_BITS_COMPAT) {
-			assert(entry->ie_request != 0);
-			dnrequest = ipc_right_dncancel(space, port,
-						       name, entry);
-			assert(dnrequest == IP_NULL);
-
-			entry->ie_object = IO_NULL;
-			ipc_entry_dealloc(space, name, entry);
-		} else
-#endif	/* MACH_IPC_COMPAT */
 		if (bits & MACH_PORT_TYPE_SEND) {
 			assert(IE_BITS_TYPE(bits) ==
 					MACH_PORT_TYPE_SEND_RECEIVE);
@@ -1149,11 +1014,6 @@ ipc_right_delta(space, name, entry, righ
 		assert(port != IP_NULL);
 
 		if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 			assert(!(entry->ie_bits & MACH_PORT_TYPE_SEND_ONCE));
 			goto invalid_right;
 		}
@@ -1195,11 +1055,6 @@ ipc_right_delta(space, name, entry, righ
 				goto invalid_right;
 			}
 
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = entry->ie_bits;
 		} else if ((bits & MACH_PORT_TYPE_DEAD_NAME) == 0)
 			goto invalid_right;
@@ -1247,11 +1102,6 @@ ipc_right_delta(space, name, entry, righ
 		assert(port != IP_NULL);
 
 		if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 			assert((entry->ie_bits & MACH_PORT_TYPE_SEND) == 0);
 			goto invalid_right;
 		}
@@ -1332,12 +1182,6 @@ ipc_right_delta(space, name, entry, righ
     urefs_overflow:
 	is_write_unlock(space);
 	return KERN_UREFS_OVERFLOW;
-
-#if	MACH_IPC_COMPAT
-    invalid_name:
-	is_write_unlock(space);
-	return KERN_INVALID_NAME;
-#endif	/* MACH_IPC_COMPAT */
 }
 
 /*
@@ -1367,13 +1211,6 @@ ipc_right_info(
 		ipc_port_t port = (ipc_port_t) entry->ie_object;
 
 		if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT) {
-				is_write_unlock(space);
-				return KERN_INVALID_NAME;
-			}
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = entry->ie_bits;
 			assert(IE_BITS_TYPE(bits) == MACH_PORT_TYPE_DEAD_NAME);
 		} else
@@ -1383,11 +1220,6 @@ ipc_right_info(
 	type = IE_BITS_TYPE(bits);
 	request = entry->ie_request;
 
-#if	MACH_IPC_COMPAT
-	if (bits & IE_BITS_COMPAT)
-		type |= MACH_PORT_TYPE_COMPAT;
-	else
-#endif	/* MACH_IPC_COMPAT */
 	if (request != 0)
 		type |= MACH_PORT_TYPE_DNREQUEST;
 	if (bits & IE_BITS_MAREQUEST)
@@ -1446,11 +1278,6 @@ ipc_right_copyin_check(
 		ip_unlock(port);
 
 		if (!active) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				return FALSE;
-#endif	/* MACH_IPC_COMPAT */
-
 			break;
 		}
 
@@ -1628,11 +1455,6 @@ ipc_right_copyin(
 		assert(port != IP_NULL);
 
 		if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = entry->ie_bits;
 			goto copy_dead;
 		}
@@ -1675,11 +1497,6 @@ ipc_right_copyin(
 		assert(port != IP_NULL);
 
 		if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = entry->ie_bits;
 			goto move_dead;
 		}
@@ -1751,11 +1568,6 @@ ipc_right_copyin(
 		assert(port != IP_NULL);
 
 		if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = entry->ie_bits;
 			goto move_dead;
 		}
@@ -1830,11 +1642,6 @@ ipc_right_copyin(
 
     invalid_right:
 	return KERN_INVALID_RIGHT;
-
-#if	MACH_IPC_COMPAT
-    invalid_name:
-	return KERN_INVALID_NAME;
-#endif	/* MACH_IPC_COMPAT */
 }
 
 /*
@@ -1960,11 +1767,6 @@ ipc_right_copyin_two(
 	assert(port != IP_NULL);
 
 	if (ipc_right_check(space, port, name, entry)) {
-#if	MACH_IPC_COMPAT
-		if (bits & IE_BITS_COMPAT)
-			goto invalid_name;
-#endif	/* MACH_IPC_COMPAT */
-
 		goto invalid_right;
 	}
 	/* port is locked and active */
@@ -2013,11 +1815,6 @@ ipc_right_copyin_two(
 
     invalid_right:
 	return KERN_INVALID_RIGHT;
-
-#if	MACH_IPC_COMPAT
-    invalid_name:
-	return KERN_INVALID_NAME;
-#endif	/* MACH_IPC_COMPAT */
 }
 
 /*
@@ -2252,14 +2049,6 @@ ipc_right_rename(
 		assert(port != IP_NULL);
 
 		if (ipc_right_check(space, port, oname, oentry)) {
-#if	MACH_IPC_COMPAT
-			if (bits & IE_BITS_COMPAT) {
-				ipc_entry_dealloc(space, nname, nentry);
-				is_write_unlock(space);
-				return KERN_INVALID_NAME;
-			}
-#endif	/* MACH_IPC_COMPAT */
-
 			bits = oentry->ie_bits;
 			assert(IE_BITS_TYPE(bits) == MACH_PORT_TYPE_DEAD_NAME);
 			assert(oentry->ie_request == 0);
@@ -2351,412 +2140,3 @@ ipc_right_rename(
 
 	return KERN_SUCCESS;
 }
-
-#if	MACH_IPC_COMPAT
-
-/*
- *	Routine:	ipc_right_copyin_compat
- *	Purpose:
- *		Copyin a capability from a space.
- *		If successful, the caller gets a ref
- *		for the resulting object, which is always valid.
- *	Conditions:
- *		The space is write-locked, and is unlocked upon return.
- *		The space must be active.
- *	Returns:
- *		KERN_SUCCESS		Acquired a valid object.
- *		KERN_INVALID_RIGHT	Name doesn't denote correct right.
- *		KERN_INVALID_NAME	[MACH_IPC_COMPAT]
- *			Caller should pretend lookup of entry failed.
- */
-
-kern_return_t
-ipc_right_copyin_compat(space, name, entry, msgt_name, dealloc, objectp)
-	ipc_space_t space;
-	mach_port_t name;
-	ipc_entry_t entry;
-	mach_msg_type_name_t msgt_name;
-	boolean_t dealloc;
-	ipc_object_t *objectp;
-{
-	ipc_entry_bits_t bits = entry->ie_bits;
-
-	assert(space->is_active);
-
-	switch (msgt_name) {
-	    case MSG_TYPE_PORT:
-		if (dealloc) {
-			ipc_port_t port;
-			ipc_port_t dnrequest;
-
-			/*
-			 *	Pulls a send right out of the space,
-			 *	leaving the space with no rights.
-			 *	Not allowed to destroy the port,
-			 *	so the space can't have receive rights.
-			 *	Doesn't operate on dead names.
-			 */
-
-			if (IE_BITS_TYPE(bits) != MACH_PORT_TYPE_SEND)
-				goto invalid_right;
-
-			port = (ipc_port_t) entry->ie_object;
-			assert(port != IP_NULL);
-
-			if (ipc_right_check(space, port, name, entry)) {
-				if (bits & IE_BITS_COMPAT)
-					goto invalid_name;
-
-				goto invalid_right;
-			}
-			/* port is locked and active */
-
-			dnrequest = ipc_right_dncancel_macro(space, port,
-							     name, entry);
-
-			assert(port->ip_srights > 0);
-			ip_unlock(port);
-
-			if (bits & IE_BITS_MAREQUEST)
-				ipc_marequest_cancel(space, name);
-
-			entry->ie_object = IO_NULL;
-			ipc_entry_dealloc(space, name, entry);
-			is_write_unlock(space);
-
-			if (dnrequest != IP_NULL)
-				ipc_notify_port_deleted(dnrequest, name);
-
-			*objectp = (ipc_object_t) port;
-			break;
-		} else {
-			ipc_port_t port;
-
-			/*
-			 *	Pulls a send right out of the space,
-			 *	making a send right if necessary.
-			 *	Doesn't operate on dead names.
-			 */
-
-			if ((bits & MACH_PORT_TYPE_SEND_RECEIVE) == 0)
-				goto invalid_right;
-
-			port = (ipc_port_t) entry->ie_object;
-			assert(port != IP_NULL);
-
-			if (ipc_right_check(space, port, name, entry)) {
-				if (bits & IE_BITS_COMPAT)
-					goto invalid_name;
-
-				goto invalid_right;
-			}
-			/* port is locked and active */
-
-			is_write_unlock(space);
-
-			if ((bits & MACH_PORT_TYPE_SEND) == 0) {
-				assert(IE_BITS_TYPE(bits) ==
-						MACH_PORT_TYPE_RECEIVE);
-				assert(IE_BITS_UREFS(bits) == 0);
-
-				port->ip_mscount++;
-			}
-
-			port->ip_srights++;
-			ip_reference(port);
-			ip_unlock(port);
-
-			*objectp = (ipc_object_t) port;
-			break;
-		}
-
-	    case MSG_TYPE_PORT_ALL:
-		if (dealloc) {
-			ipc_port_t port;
-			ipc_port_t dnrequest = IP_NULL;
-			ipc_port_t nsrequest = IP_NULL;
-			mach_port_mscount_t mscount = 0; /* '=0' to shut up lint */
-
-			/*
-			 *	Like MACH_MSG_TYPE_MOVE_RECEIVE, except that
-			 *	the space is always left without rights,
-			 *	so we kill send rights if necessary.
-			 */
-
-			if ((bits & MACH_PORT_TYPE_RECEIVE) == 0)
-				goto invalid_right;
-
-			port = (ipc_port_t) entry->ie_object;
-			assert(port != IP_NULL);
-
-			ip_lock(port);
-			assert(ip_active(port));
-			assert(port->ip_receiver_name == name);
-			assert(port->ip_receiver == space);
-
-			dnrequest = ipc_right_dncancel_macro(space, port,
-							     name, entry);
-
-			if (bits & IE_BITS_MAREQUEST)
-				ipc_marequest_cancel(space, name);
-
-			entry->ie_object = IO_NULL;
-			ipc_entry_dealloc(space, name, entry);
-			is_write_unlock(space);
-
-			if (bits & MACH_PORT_TYPE_SEND) {
-				assert(IE_BITS_TYPE(bits) ==
-						MACH_PORT_TYPE_SEND_RECEIVE);
-				assert(IE_BITS_UREFS(bits) > 0);
-				assert(port->ip_srights > 0);
-
-				if (--port->ip_srights == 0) {
-					nsrequest = port->ip_nsrequest;
-					if (nsrequest != IP_NULL) {
-						port->ip_nsrequest = IP_NULL;
-						mscount = port->ip_mscount;
-					}
-				}
-			}
-
-			ipc_port_clear_receiver(port);
-
-			port->ip_receiver_name = MACH_PORT_NULL;
-			port->ip_destination = IP_NULL;
-			ip_unlock(port);
-
-			if (nsrequest != IP_NULL)
-				ipc_notify_no_senders(nsrequest, mscount);
-
-			if (dnrequest != IP_NULL)
-				ipc_notify_port_deleted(dnrequest, name);
-
-			*objectp = (ipc_object_t) port;
-			break;
-		} else {
-			ipc_port_t port;
-
-			/*
-			 *	Like MACH_MSG_TYPE_MOVE_RECEIVE, except that
-			 *	the space is always left with send rights,
-			 *	so we make a send right if necessary.
-			 */
-
-			if ((bits & MACH_PORT_TYPE_RECEIVE) == 0)
-				goto invalid_right;
-
-			port = (ipc_port_t) entry->ie_object;
-			assert(port != IP_NULL);
-
-			ip_lock(port);
-			assert(ip_active(port));
-			assert(port->ip_receiver_name == name);
-			assert(port->ip_receiver == space);
-
-			if ((bits & MACH_PORT_TYPE_SEND) == 0) {
-				assert(IE_BITS_TYPE(bits) ==
-						MACH_PORT_TYPE_RECEIVE);
-				assert(IE_BITS_UREFS(bits) == 0);
-
-				/* ip_mscount will be cleared below */
-				port->ip_srights++;
-				bits |= MACH_PORT_TYPE_SEND | 1;
-			}
-
-			ipc_hash_insert(space, (ipc_object_t) port,
-					name, entry);
-
-			entry->ie_bits = bits &~ MACH_PORT_TYPE_RECEIVE;
-			is_write_unlock(space);
-
-			ipc_port_clear_receiver(port); /* clears ip_mscount */
-
-			port->ip_receiver_name = MACH_PORT_NULL;
-			port->ip_destination = IP_NULL;
-			ip_reference(port);
-			ip_unlock(port);
-
-			*objectp = (ipc_object_t) port;
-			break;
-		}
-
-	    default:
-#if MACH_ASSERT
-		assert(!"ipc_right_copyin_compat: strange rights");
-#else
-		panic("ipc_right_copyin_compat: strange rights");
-#endif
-	}
-
-	return KERN_SUCCESS;
-
-    invalid_right:
-	is_write_unlock(space);
-	return KERN_INVALID_RIGHT;
-
-    invalid_name:
-	is_write_unlock(space);
-	return KERN_INVALID_NAME;
-}
-
-/*
- *	Routine:	ipc_right_copyin_header
- *	Purpose:
- *		Copyin a capability from a space.
- *		If successful, the caller gets a ref
- *		for the resulting object, which is always valid.
- *		The type of the acquired capability is returned.
- *	Conditions:
- *		The space is write-locked, and is unlocked upon return.
- *		The space must be active.
- *	Returns:
- *		KERN_SUCCESS		Acquired a valid object.
- *		KERN_INVALID_RIGHT	Name doesn't denote correct right.
- *		KERN_INVALID_NAME	[MACH_IPC_COMPAT]
- *			Caller should pretend lookup of entry failed.
- */
-
-kern_return_t
-ipc_right_copyin_header(space, name, entry, objectp, msgt_namep)
-	ipc_space_t space;
-	mach_port_t name;
-	ipc_entry_t entry;
-	ipc_object_t *objectp;
-	mach_msg_type_name_t *msgt_namep;
-{
-	ipc_entry_bits_t bits = entry->ie_bits;
-	mach_port_type_t type = IE_BITS_TYPE(bits);
-
-	assert(space->is_active);
-
-	switch (type) {
-	    case MACH_PORT_TYPE_PORT_SET:
-	    case MACH_PORT_TYPE_DEAD_NAME:
-		goto invalid_right;
-
-	    case MACH_PORT_TYPE_RECEIVE: {
-		ipc_port_t port;
-
-		/*
-		 *	Like MACH_MSG_TYPE_MAKE_SEND.
-		 */
-
-		port = (ipc_port_t) entry->ie_object;
-		assert(port != IP_NULL);
-
-		ip_lock(port);
-		assert(ip_active(port));
-		assert(port->ip_receiver_name == name);
-		assert(port->ip_receiver == space);
-		is_write_unlock(space);
-
-		port->ip_mscount++;
-		port->ip_srights++;
-		ip_reference(port);
-		ip_unlock(port);
-
-		*objectp = (ipc_object_t) port;
-		*msgt_namep = MACH_MSG_TYPE_PORT_SEND;
-		break;
-	    }
-
-	    case MACH_PORT_TYPE_SEND:
-	    case MACH_PORT_TYPE_SEND_RECEIVE: {
-		ipc_port_t port;
-
-		/*
-		 *	Like MACH_MSG_TYPE_COPY_SEND,
-		 *	except that the port must be alive.
-		 */
-
-		assert(IE_BITS_UREFS(bits) > 0);
-
-		port = (ipc_port_t) entry->ie_object;
-		assert(port != IP_NULL);
-
-		if (ipc_right_check(space, port, name, entry)) {
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-
-			goto invalid_right;
-		}
-		/* port is locked and active */
-
-		assert(port->ip_srights > 0);
-		is_write_unlock(space);
-
-		port->ip_srights++;
-		ip_reference(port);
-		ip_unlock(port);
-
-		*objectp = (ipc_object_t) port;
-		*msgt_namep = MACH_MSG_TYPE_PORT_SEND;
-		break;
-	    }
-
-	    case MACH_PORT_TYPE_SEND_ONCE: {
-		ipc_port_t port;
-		ipc_port_t dnrequest, notify;
-
-		/*
-		 *	Like MACH_MSG_TYPE_MOVE_SEND_ONCE,
-		 *	except that the port must be alive
-		 *	and a port-deleted notification is generated.
-		 */
-
-		assert(IE_BITS_UREFS(bits) == 1);
-		assert((bits & IE_BITS_MAREQUEST) == 0);
-
-		port = (ipc_port_t) entry->ie_object;
-		assert(port != IP_NULL);
-
-		if (ipc_right_check(space, port, name, entry)) {
-			if (bits & IE_BITS_COMPAT)
-				goto invalid_name;
-
-			goto invalid_right;
-		}
-		/* port is locked and active */
-
-		assert(port->ip_sorights > 0);
-
-		dnrequest = ipc_right_dncancel_macro(space, port, name, entry);
-		ip_unlock(port);
-
-		entry->ie_object = IO_NULL;
-		ipc_entry_dealloc(space, name, entry);
-
-		notify = ipc_space_make_notify(space);
-		is_write_unlock(space);
-
-		if (dnrequest != IP_NULL)
-			ipc_notify_port_deleted(dnrequest, name);
-
-		if (IP_VALID(notify))
-			ipc_notify_port_deleted_compat(notify, name);
-
-		*objectp = (ipc_object_t) port;
-		*msgt_namep = MACH_MSG_TYPE_PORT_SEND_ONCE;
-		break;
-	    }
-
-	    default:
-#if MACH_ASSERT
-		assert(!"ipc_right_copyin_header: strange rights");
-#else
-		panic("ipc_right_copyin_header: strange rights");
-#endif
-	}
-
-	return KERN_SUCCESS;
-
-    invalid_right:
-	is_write_unlock(space);
-	return KERN_INVALID_RIGHT;
-
-    invalid_name:
-	is_write_unlock(space);
-	return KERN_INVALID_NAME;
-}
-
-#endif	/* MACH_IPC_COMPAT */
diff -Npur gnumach.old/ipc/ipc_right.h gnumach.new/ipc/ipc_right.h
--- gnumach.old/ipc/ipc_right.h	2001-04-05 03:39:19.000000000 -0300
+++ gnumach.new/ipc/ipc_right.h	2006-04-05 13:19:36.000000000 -0300
@@ -36,8 +36,6 @@
 #ifndef	_IPC_IPC_RIGHT_H_
 #define	_IPC_IPC_RIGHT_H_
 
-#include <mach_ipc_compat.h>
-
 #include <mach/boolean.h>
 #include <mach/kern_return.h>
 #include <ipc/ipc_port.h>
@@ -110,15 +108,4 @@ extern kern_return_t
 ipc_right_rename(/* ipc_space_t, mach_port_t, ipc_entry_t,
 		    mach_port_t, ipc_entry_t */);
 
-#if	MACH_IPC_COMPAT
-
-extern kern_return_t
-ipc_right_copyin_compat(/* ipc_space_t, mach_port_t, ipc_entry_t,
-			   mach_msg_type_name_t, boolean_t, ipc_object_t * */);
-
-extern kern_return_t
-ipc_right_copyin_header(/* ipc_space_t, mach_port_t, ipc_entry_t,
-			   ipc_object_t *, mach_msg_type_name_t * */);
-
-#endif	/* MACH_IPC_COMPAT */
 #endif	/* _IPC_IPC_RIGHT_H_ */
diff -Npur gnumach.old/ipc/ipc_space.c gnumach.new/ipc/ipc_space.c
--- gnumach.old/ipc/ipc_space.c	2006-03-20 08:31:36.000000000 -0300
+++ gnumach.new/ipc/ipc_space.c	2006-04-05 13:10:16.000000000 -0300
@@ -36,8 +36,6 @@
  *	Functions to manipulate IPC capability spaces.
  */
 
-#include <mach_ipc_compat.h>
-
 #include <mach/boolean.h>
 #include <mach/kern_return.h>
 #include <mach/port.h>
@@ -149,33 +147,6 @@ ipc_space_create(
 	space->is_tree_small = 0;
 	space->is_tree_hash = 0;
 
-#if	MACH_IPC_COMPAT
-    {
-	mach_port_t name;
-	ipc_port_t port;
-	kern_return_t kr;
-
-	/*
-	 *	ipc_port_alloc_compat probably won't look at is_notify,
-	 *	but make sure all fields have sane values anyway.
-	 */
-
-	space->is_notify = IP_NULL;
-
-	kr = ipc_port_alloc_compat(space, &name, &port);
-	if (kr != KERN_SUCCESS) {
-		ipc_space_destroy(space);
-		is_release(space);
-		return kr;
-	}
-
-	ip_reference(port);
-	port->ip_srights++;
-	ip_unlock(port);
-	space->is_notify = port;
-    }
-#endif	/* MACH_IPC_COMPAT */
-
 	*spacep = space;
 	return KERN_SUCCESS;
 }
@@ -298,11 +269,6 @@ ipc_space_destroy(
 	}
 	ipc_splay_traverse_finish(&space->is_tree);
 
-#if	MACH_IPC_COMPAT
-	if (IP_VALID(space->is_notify))
-		ipc_port_release_send(space->is_notify);
-#endif	/* MACH_IPC_COMPAT */
-
 	/*
 	 *	Because the space is now dead,
 	 *	we must release the "active" reference for it.
diff -Npur gnumach.old/ipc/ipc_space.h gnumach.new/ipc/ipc_space.h
--- gnumach.old/ipc/ipc_space.h	2006-03-20 08:31:36.000000000 -0300
+++ gnumach.new/ipc/ipc_space.h	2006-04-05 13:37:10.000000000 -0300
@@ -39,8 +39,6 @@
 #ifndef	_IPC_IPC_SPACE_H_
 #define _IPC_IPC_SPACE_H_
 
-#include <mach_ipc_compat.h>
-
 #include <mach/boolean.h>
 #include <mach/kern_return.h>
 #include <kern/macro_help.h>
@@ -78,10 +76,6 @@ struct ipc_space {
 	ipc_entry_num_t is_tree_total;	/* number of entries in the tree */
 	ipc_entry_num_t is_tree_small;	/* # of small entries in the tree */
 	ipc_entry_num_t is_tree_hash;	/* # of hashed entries in the tree */
-
-#if	MACH_IPC_COMPAT
-	struct ipc_port *is_notify;	/* notification port */
-#endif	/* MACH_IPC_COMPAT */
 };
 
 #define	IS_NULL			((ipc_space_t) 0)
@@ -138,23 +132,4 @@ kern_return_t	ipc_space_create(/* ipc_ta
 kern_return_t	ipc_space_create_special(struct ipc_space **);
 void		ipc_space_destroy(struct ipc_space *);
 
-#if	MACH_IPC_COMPAT
-
-/*
- *	Routine:	ipc_space_make_notify
- *	Purpose:
- *		Given a space, return a send right for a notification.
- *		May return IP_NULL/IP_DEAD.
- *	Conditions:
- *		The space is locked (read or write) and active.
- *
- *	ipc_port_t
- *	ipc_space_make_notify(space)
- *		ipc_space_t space;
- */
-
-#define	ipc_space_make_notify(space)	\
-		ipc_port_copy_send(space->is_notify)
-
-#endif	/* MACH_IPC_COMPAT */
 #endif	/* _IPC_IPC_SPACE_H_ */
diff -Npur gnumach.old/ipc/mach_debug.c gnumach.new/ipc/mach_debug.c
--- gnumach.old/ipc/mach_debug.c	2001-04-05 03:39:20.000000000 -0300
+++ gnumach.new/ipc/mach_debug.c	2006-04-05 13:06:20.000000000 -0300
@@ -33,8 +33,6 @@
  *	Exported kernel calls.  See mach_debug/mach_debug.defs.
  */
 
-#include <mach_ipc_compat.h>
-
 #include <mach/kern_return.h>
 #include <mach/port.h>
 #include <mach/machine/vm_types.h>
@@ -381,11 +379,7 @@ mach_port_space_info(
 
 		iin->iin_name = MACH_PORT_MAKEB(index, bits);
 		iin->iin_collision = (bits & IE_BITS_COLLISION) ? TRUE : FALSE;
-#if	MACH_IPC_COMPAT
-		iin->iin_compat = (bits & IE_BITS_COMPAT) ? TRUE : FALSE;
-#else	/* MACH_IPC_COMPAT */
 		iin->iin_compat = FALSE;
-#endif	/* MACH_IPC_COMPAT */
 		iin->iin_marequest = (bits & IE_BITS_MAREQUEST) ? TRUE : FALSE;
 		iin->iin_type = IE_BITS_TYPE(bits);
 		iin->iin_urefs = IE_BITS_UREFS(bits);
@@ -406,11 +400,7 @@ mach_port_space_info(
 
 		iin->iin_name = tentry->ite_name;
 		iin->iin_collision = (bits & IE_BITS_COLLISION) ? TRUE : FALSE;
-#if	MACH_IPC_COMPAT
-		iin->iin_compat = (bits & IE_BITS_COMPAT) ? TRUE : FALSE;
-#else	/* MACH_IPC_COMPAT */
 		iin->iin_compat = FALSE;
-#endif	/* MACH_IPC_COMPAT */
 		iin->iin_marequest = (bits & IE_BITS_MAREQUEST) ? TRUE : FALSE;
 		iin->iin_type = IE_BITS_TYPE(bits);
 		iin->iin_urefs = IE_BITS_UREFS(bits);
